<?php
if ( ! defined( 'WPINC' ) ) {
	die;
}

class Elementor_Tracker_Updater {
    
    public function __construct() {
        /**
		 * To Remove Transient cache (force check)
		 * set_site_transient( 'update_plugins', null );
		 */
        add_action( 'pre_set_site_transient_update_plugins', array( $this, 'update' ) );
    }

    public function update( $data ) {
		$slug = 'elementor-tracker';
		$plugin = 'elementor-tracker/elementor-tracker.php';

		$new_update = $this->check_update();
		if ( $new_update['version'] ) {
			$update = new stdClass();
			$update->slug        = $slug;
			$update->plugin      = $plugin;
			$update->new_version = $new_update['version'];
			$update->url         = false;
			$update->package     = $new_update['package'];
			$data->response[$plugin] = $update;
		}
		return $data;
	}

    private function check_update() {
		$response = $this->remote_query();
		if (!$response) {
			return array( 'version' => false );
        }
        
		if (version_compare(ELEMENTOR_TRACKER_CURRENT_VERSION, $response->version, '<' ) ) {
			return array(
				'version' => $response->version,
				'package' => $response->download_url,
			);
		}
		return array( 'version' => false );
	}

    private function remote_query() {
        $response = wp_remote_get('https://wp-updates.apps.assafdev.io/?action=get_metadata&slug=elementor-tracker');
        if ( is_wp_error( $response ) || wp_remote_retrieve_response_code( $response ) != '200' ) {
			return false;
        }
        $response = json_decode( $response['body'] );
		return $response;
    }
}